<template>
  <main v-if="book" class="main">
    <b-row class="position-relative">
      <div class="line bg-light border-top" />
      <b-col md="7">
        <slick-carousel ref="bookSlider" v-bind="carouselSettings" class="book-slider">
          <div v-if="book.video" class="book-slider__cover">
            <template v-if="isVideo">
              <iframe
                :src="'https://www.youtube.com/embed/' + videoId + '?autoplay=1&mute=1'"
                :height="videoHeight"
                frameborder="0"
                allow="autoplay;"
              />
              <!--              <client-only>-->
              <!--                <youtube :video-id="videoId" :player-vars="{ autoplay: 1 }" />-->
              <!--              </client-only>-->
            </template>
            <template v-else>
              <v-lazy-image
                :src-placeholder="book.cover | image | imageSize('small')"
                :src="book.cover | image"
                :alt="book.title"
                class="w-100 book-slider__image"
              />
              <div class="play" @click="playVideo()">
                <b-img src="@/static/icons/play.svg" alt="Play" />
              </div>
            </template>
          </div>
          <div v-for="(image, index) in book.images" :key="'bookImage-' + index">
            <v-lazy-image
              :src-placeholder="image | image | imageSize('small')"
              :src="image | image"
              :alt="book.title"
              class="w-100 book-slider__image"
            />
          </div>
        </slick-carousel>
      </b-col>
      <b-col md="5">
        <div class="px-3 py-4 p-md-3 p-lg-4 p-xl-5">
          <h1 class="font-weight-bold text-dark mb-3 book-title h3">
            {{ book.title }}
          </h1>
          <div class="mb-1">
            <span
              v-if="price"
              class="text-danger font-weight-bold h5"
              v-html="$options.filters.price(price, currency || 'KZT')"
            />
          </div>
          <div class="book-excerpt pr-lg-3 pr-xl-5" v-html="book.excerpt" />
        </div>
      </b-col>
    </b-row>
    <div class="bg-light border-bottom pt-2 pb-3">
      <b-container>
        <namebook-form :book="book" />
      </b-container>
    </div>
    <section class="py-5 namebook-info">
      <div class="container">
        <div class="d-flex align-items-center justify-content-start flex-column">
          <b-img :src="timeline" alt="Timeline" class="mb-5 img-fluid" />
        </div>
      </div>
    </section>
    <app-infoblocks class="border-top" :items="infoblocks" />
    <b-toast id="interestToast" variant="warning" solid>
      <template v-slot:toast-title>
        <div class="d-flex flex-grow-1 align-items-center">
          <b-img src="~/static/icons/bell.svg" class="mr-2" width="16" alt="Bell" />
          <strong class="mr-auto">{{ $t('notice.namebook.title') }}</strong>
        </div>
      </template>
      {{ $t('notice.namebook.content') }}
    </b-toast>
  </main>
</template>
<script>
import hexToRgba from 'hex-to-rgba'
import { mapGetters, mapActions } from 'vuex'
import namebookForm from '~/components/namebook/Form.vue'
import appInfoblocks from '~/components/Infoblocks.vue'
import timelineRU from '~/static/images/timeline_ru.png'
import timelineKK from '~/static/images/timeline_kk.png'
import timelineRUMobile from '~/static/images/timeline_ru_mobile.png'
import timelineKKMobile from '~/static/images/timeline_kk_mobile.png'

export default {
  name: 'AppNamebookPage',
  components: {
    namebookForm,
    appInfoblocks
  },
  async fetch ({ store, params }) {
    await store.dispatch('book/FETCH_BOOK', {
      id: params.id,
      type: 'namebooks'
    })
  },
  data () {
    return {
      carouselSettings: {
        arrows: true,
        dots: true,
        infinite: true,
        autoplay: false,
        pauseOnDotsHover: true,
        pauseOnFocus: true,
        pauseOnHover: true,
        accessibility: false,
        draggable: false
      },
      isVideo: false,
      videoId: '',
      videoHeight: 300,
      infoblocks: [],
      timeline: null
    }
  },
  computed: {
    ...mapGetters({
      book: 'book/getBook',
      currency: 'currency/getCurrency',
      currencies: 'currency/getCurrencies'
    }),
    price () {
      if (this.currency && this.currencies.length) {
        const currency = this.currencies.find(item => item.kod === this.currency)
        if (currency.kod === 'KZT') {
          return this.book.price
        }
        return (this.book.price / parseFloat(currency.kurs)).toFixed(2)
      }
      return this.book.price
    }
  },
  mounted () {
    if (this.currencies.length === 0) {
      this.fetchCurrencies()
    }
    this.getInfoblocks()
    const timer = Math.round((Math.random() * 100000))
    setTimeout(() => {
      this.$bvToast.show('interestToast')
    }, timer)

    if (this.$device.isMobile) {
      if (this.$i18n.locale === 'kk') {
        this.timeline = timelineKKMobile
      } else {
        this.timeline = timelineRUMobile
      }
    } else if (this.$i18n.locale === 'kk') {
      this.timeline = timelineKK
    } else {
      this.timeline = timelineRU
    }
  },
  methods: {
    toRGBA (color, point) {
      return hexToRgba(color, point)
    },
    playVideo () {
      this.videoId = this.$youtube.getIdFromURL(this.book.video)
      this.isVideo = true
      if (this.$device.isMobile) {
        this.videoHeight = this.$refs.bookSlider.$el.clientWidth * 0.6825
      } else {
        this.videoHeight = this.$refs.bookSlider.$el.clientWidth * 0.56
      }
    },
    async getInfoblocks () {
      const { data } = await this.$axios.$get('namebooks/' + this.book.id + '/infoblocks')
      this.infoblocks = data
    },
    ...mapActions({
      fetchCurrencies: 'currency/FETCH_CURRENCIES'
    })
  },
  head () {
    const title = this.book.title
    const description = this.book.meta.description
    const keywords = this.book.meta.keywords
    const image = this.$options.filters.image(this.book.cover)
    return {
      title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: description
        },
        {
          hid: 'og:title',
          property: 'og:title',
          content: title
        },
        {
          hid: 'og:description',
          property: 'og:description',
          content: description
        },
        {
          hid: 'keywords',
          name: 'keywords',
          content: keywords
        },
        {
          hid: 'og:image',
          property: 'og:image',
          content: image
        },
        {
          hid: 'og:image:width',
          property: 'og:image:width',
          content: '1000'
        },
        {
          hid: 'og:image:height',
          property: 'og:image:height',
          content: null
        }
      ]
    }
  }
}
</script>

<style lang="scss">
    //noinspection CssUnknownTarget
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";

    @include media-breakpoint-down(md) {
      .h5.text-danger {
        font-size: $font-size-base;
      }
    }

    .book-title {
      @include media-breakpoint-down(md) {
        font-size: $font-size-lg;
      }
    }

    .book-slider {
        .book-slider__img, iframe, .v-lazy-image {
          width: 100%;
          min-height: 20rem;
          max-height: 35rem;
          object-fit: cover;
          @include media-breakpoint-down(lg) {
            min-height: 26rem;
          }
          @include media-breakpoint-down(sm) {
            min-height: 16rem;
            max-height: 25rem;
          }
        }

        .slick-dots {
            bottom: 2rem;
            z-index: 10000;
            @include media-breakpoint-down(sm) {
              bottom: 0.5rem;
              transform: translateY(100%);
            }
            li {
                button:before {
                    font-size: 0.5rem;
                }
            }
        }

        &__cover {
            position: relative;

            .play {
                position: absolute;
                left: 50%;
                top: 50%;
                transform: translate(-50%, -50%);
                background-color: rgba(black, 0.5);
                backdrop-filter: blur(4px);
                border: 1px solid $dark;
                padding: 2rem;
                border-radius: 50%;
                display: flex;
                align-items: center;
                justify-content: center;
                cursor: pointer;
                transition: all 0.7s ease;

                img {
                    width: 2rem;
                    height: 2rem;
                    object-fit: contain;
                    transition: all 0.3s ease;
                }

                @include media-breakpoint-down(sm) {
                  padding: 1rem;
                  img {
                    width: 1rem;
                    height: 1rem;
                  }
                }

                &:hover {
                    transform: translate(-50%, -50%) scale(1.2);

                    img {
                        transform: scale(1.5);
                    }
                }
            }
        }

        .slick-arrow {
            opacity: 0;
            transition: all 0.3s ease;
            z-index: 1000;
            width: 3rem;
            height: 3rem;

            &::before {
                font-size: 3rem;
            }

            &.slick-prev {
                left: 1rem;
            }

            &.slick-next {
                right: 1rem;
            }
        }

        &:hover {
            .slick-arrow {
                opacity: 1;
            }
        }
    }

    .main .line {
        height: 7px;
        width: 100%;
        position: absolute;
        left: 0;
        bottom: 0;
    }

    .book-excerpt {
        color: $secondary;
        img {
          max-width: 100%;
        }

        ul {
            margin: 0;
            padding: 0;
            list-style: none;

            li {
                display: flex;
                flex-direction: row;
                align-items: center;
                justify-content: flex-start;
                margin-bottom: 0.25rem;

                img {
                    width: 1.5rem !important;
                    height: 1.5rem !important;
                    object-fit: contain;
                    margin-right: 0.25rem;
                }
            }
        }
    }

    .namebook-info {
        .img-fluid {
            width: 100%;
            object-fit: contain;
        }

        ul {
            li {
                display: flex;
                flex-direction: row;
                align-items: center;
                margin-bottom: 1rem;

                img {
                    width: 2rem;
                    height: 2rem;
                    object-fit: contain;
                    margin-right: 1rem;
                }
            }
        }
    }
</style>
